freeslot("MT_SLIMETRAIL", "S_SLIMETRAIL", "S_SLIMEWALL", "SPR_GOOD")

local function Splash(mo, color)
	for i = 1, 10
		local bomb = P_SpawnMobj(mo.x, mo.y, mo.z+50*FRACUNIT, MT_SLIMETRAIL)
		bomb.color = color
		bomb.state = S_SLIMETRAIL
		bomb.renderflags = RF_FULLBRIGHT
		bomb.flags2 = 0
		P_InstaThrust(bomb, P_RandomRange(0, 360)*ANG1, P_RandomRange(0, 10)*FRACUNIT)
		P_SetObjectMomZ(bomb, P_RandomRange(-5, 5)*FRACUNIT)
		if mo.eflags & MFE_VERTICALFLIP
			bomb.eflags = $|MFE_VERTICALFLIP
			bomb.flags2 = $|MF2_OBJECTFLIP
		else
			bomb.eflags = $ & ~MFE_VERTICALFLIP
			bomb.flags2 = $ & ~MF2_OBJECTFLIP
		end
	end	
end

local EMOTE_DEFAULT = 0
local EMOTE_HAPPY = 1
local EMOTE_ANGRY = 2
local EMOTE_SUPRISE = 3
local EMOTE_PAIN = 4
local EMOTE_DEAD = 5
local EMOTE_CRYING = 6
local EMOTE_AFRAID = 7

local emotes = {
	[0] = S_EYESDEF,
	[1] = S_EYESHAPPY,
	[2] = S_EYESANGRY,
	[3] = S_EYESSUPRISE,
	[4] = S_EYESPAIN,
	[5] = S_EYESDEAD,
	[6] = S_EYESCRYING,
	[7] = S_EYESAFRAID
}

local function DeletusFOFus(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high? 
	
	EV_CrumbleChain(fof)
  end
end

addHook("PlayerThink", function(p)
  if not p.mo return end
  if (p.mo.skin != "rimuru") return end
  if (p.mo.scale <= FRACUNIT) return end

  DeletusFOFus(p.mo, p.mo.subsector.sector)
end)

addHook("MobjLineCollide", function(mo, line)
  if not mo.player return end
  if (mo.skin != "rimuru") return end
   if (mo.player.mo.scale <= FRACUNIT) return end

  for _, sec in ipairs({line.frontsector, line.backsector})
    DeletusFOFus(mo, sec)
  end
end, MT_PLAYER)

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.mo.skin == "rimuru"
		if player.rotate == nil
			player.rotate = 0
		end
		player.powers[pw_spacetime] = 99999
		player.powers[pw_underwater] = 99999
		if not player.eyes
			player.eyes = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_EYES)
			player.eyes.color = player.mo.color
		end
		if player.showskill
			player.showskill = $ - 1
		end
		local slimetarg = P_LookForEnemies(player, true, true)
		if slimetarg and not (player.mo.slimed and slimetarg.slimed)
			P_SpawnLockOn(player, slimetarg, S_SLIMETARGET)
		end
		if player.mo.scale < FRACUNIT and not (player.cmd.buttons & BT_CUSTOM1)
			if (leveltime%10) == 1
				player.mo.scale = $ + FRACUNIT/50
			end	
		end
		local homret = P_LookForEnemies(player, true, false)
		if homret and displayplayer == player and player.pflags & PF_JUMPED and not (player.pflags & PF_THOKKED)
			local target = P_SpawnMobjFromMobj(homret, 0, 0, 0, MT_OVERLAY)
			target.state = S_SLIMERETICLE
			target.color = player.mo.color
			target.flags = $|MF_NOGRAVITY
			target.fuse = 2
			target.target = homret
			target.scale = FRACUNIT*2
			target.spriteyoffset = -25*FRACUNIT
			target.rollangle = ((leveltime%(360/15))*ANG1)*15
		end
		if player.mo.scale > FRACUNIT*3
			player.mo.scale = FRACUNIT*3
		end
		if player.cmd.buttons & BT_CUSTOM1
			if player.custom1 == false
			and not player.revert
				player.revertscale = player.mo.scale
				S_StartSound(player.mo, sfx_gspray)
			else
				if player.mo.scale > FRACUNIT - FRACUNIT/3
					player.mo.scale = $ - FRACUNIT/5
					P_SpawnGhostMobj(player.mo)
				end	
				player.revert = true
			end
			
			player.custom1 = true
		else
			if player.revert
				if player.mo.scale < player.revertscale
					player.mo.scale = $ + FRACUNIT/5
					P_SpawnGhostMobj(player.mo)
				else
					player.revert = false
					player.mo.scale = player.revertscale
					S_StartSound(player.mo, sfx_splash)
				end	
			end
			player.custom1 = false
		end
		if player.cmd.buttons & BT_SPIN
			if player.spin == false
			and player.mo.scale >= FRACUNIT - FRACUNIT/3
			and slimetarg and not (player.mo.slimed and slimetarg.slimed)
				player.mo.scale = $ - FRACUNIT/15
				player.slimemissile = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height/2*player.mo.scale, MT_SLIMETRAIL)
				player.slimemissile.fuse = 50
				player.slimemissile.color = player.mo.color
				player.slimemissile.flags = $|MF_NOGRAVITY
				local aim = R_PointToAngle2(player.mo.x, player.mo.y, slimetarg.x, slimetarg.y)
				P_InstaThrust(player.slimemissile, aim, 30*FRACUNIT)
				
				local slimetrail = P_SpawnMobjFromMobj(slimetarg, 0, 0, slimetarg.height/2, MT_SLIMETRAIL)
				slimetrail.fuse = 50
				slimetrail.color = player.mo.color
				slimetrail.flags = $|MF_NOGRAVITY
				local aim2 = R_PointToAngle2(slimetarg.x, slimetarg.y, player.mo.x, player.mo.y)
				P_InstaThrust(slimetrail, aim2, 30*FRACUNIT)
				
				slimetarg.slime = true
				slimetarg.colorized = true
				slimetarg.color = player.mo.color
				if slimetarg.scale < FRACUNIT*3
					slimetarg.scale = $ + FRACUNIT/50
				end
				S_StartSound(player.mo, sfx_gspray)
			end
			if player.spin == false
			and player.mo.scale >= FRACUNIT - FRACUNIT/3
			and not slimetarg
				player.mo.scale = $ - FRACUNIT/15
				player.slimemissile = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height/2*player.mo.scale, MT_SLIMETRAIL)
				player.slimemissile.fuse = 50
				player.slimemissile.color = player.mo.color
				player.slimemissile.flags = $|MF_NOGRAVITY 
				P_SetObjectMomZ(player.slimemissile, 10*player.mo.scale)
				S_StartSound(player.mo, sfx_gspray)
			end
			player.spin = true
		else
			player.spin = false
		end
		if player.eyes and player.eyes.valid
			player.eyes.color = player.mo.color
			player.eyes.angle = $ + ((player.mo.angle - player.eyes.angle)+ANGLE_90)
			player.eyes.momx = player.mo.momx
			player.eyes.momy = player.mo.momy
			player.eyes.momz = player.mo.momz
			player.eyes.scale = player.mo.scale
			if player.emotetimer
				player.emotetimer = $ - 1
				player.eyes.state = player.emote
			else
				player.eyes.state = S_EYESDEF
			end
			
			local gotox = player.mo.x + FixedMul(20*player.mo.scale, cos(player.mo.angle))
			local gotoy = player.mo.y + FixedMul(20*player.mo.scale, sin(player.mo.angle))
			local eyesview = (player.aiming/ANG1*FRACUNIT)/8
			
			P_TeleportMove(player.eyes, gotox, gotoy, player.mo.z+eyesview)
			
			if gametype == GT_COOP or gametype == GT_COMPETITION or gametype == GT_RACE
				if (player.cmd.buttons & BT_WEAPONMASK)
					player.emotetimer = 50
					local weapon = player.cmd.buttons & BT_WEAPONMASK
					player.emote = emotes[weapon]
				end
			end
		end
		player.rotate = $ + player.speed/FRACUNIT
		if not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if P_IsObjectOnGround(player.mo)
				if player.speed > FRACUNIT
					player.mo.spritexscale = (FRACUNIT+FRACUNIT/15) + FixedMul(cos(player.rotate*ANG1), FRACUNIT/15)
				else
					player.mo.spritexscale = FRACUNIT
				end	
				player.mo.spriteyscale = FRACUNIT
			else
				if player.mo.momz > -10*FRACUNIT
					player.mo.spritexscale = FRACUNIT - FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
					player.mo.spriteyscale = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
				else
					player.mo.spritexscale = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
					player.mo.spriteyscale = FRACUNIT - FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
				end
			end
			if player.pflags & PF_JUMPED
				if not player.mo.slimed
					local trail = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SLIMETRAIL)
					trail.state = S_SLIMETRAIL
					trail.fuse = 2
					trail.color = player.mo.color
					trail.trail = true
					trail.spritexscale = FRACUNIT + FRACUNIT/2
				else
					local trail = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
					trail.state = S_SLIMETRAIL
					trail.fuse = 2
					trail.color = player.mo.color
					trail.trail = true
					trail.scale = FRACUNIT*2
					trail.target = player.mo.slimed
				end	
			end
			if player.mo.slimed
				P_TeleportMove(player.mo, player.mo.slimed.x, player.mo.slimed.y, player.mo.slimed.z)
				player.powers[pw_flashing] = 3
				player.mo.slimed.scale = $ - FRACUNIT/15
				player.mo.flags2 = $|MF2_DONTDRAW
				player.eyes.flags2 = $|MF2_DONTDRAW
				player.mo.slimed.colorized = true
				player.mo.slimed.color = player.mo.color
				player.pflags = $|PF_JUMPED
				player.target = P_LookForEnemies(player, false, false)
				if player.target and player.cmd.buttons & BT_JUMP
					P_SpawnLockOn(player, player.target, S_SLIMETARGET)
				end
				local bubbles = {
				sfx_bubbl1,
				sfx_bubbl2,
				sfx_bubbl3,
				sfx_bubbl4,
				sfx_bubbl5}
				S_StartSound(player.mo, bubbles[P_RandomRange(1, 5)])
				if player.mo.slimed.scale <= FRACUNIT/15
					if player.mo.slimed.startscale
						player.mo.scale = $ + (FRACUNIT/5) + (player.mo.slimed.startscale-FRACUNIT)
					else
						player.mo.scale = $ + (FRACUNIT/5)
					end	
					P_KillMobj(player.mo.slimed, player.mo, player.mo)
					player.mo.slimed.slimed = nil
					player.mo.slimed = nil
					player.mo.flags2 = $ & ~MF2_DONTDRAW
					P_SetObjectMomZ(player.mo, -10*FRACUNIT)
					player.eyes.flags2 = $ & ~MF2_DONTDRAW
					S_StartSound(player.mo, sfx_bnce2)
					if player.target and player.cmd.buttons & BT_JUMP
						player.powers[pw_flashing] = 15
						local slime = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height/2*player.mo.scale, MT_SLIMETRAIL)
						slime.state = S_SLIMETRAIL
						slime.fuse = 15
						slime.color = player.mo.color
						P_InstaThrust(slime, R_PointToAngle2(player.mo.x, player.mo.y, player.target.x, player.target.y), 30*FRACUNIT)
						player.target.slimed = player.mo
						player.mo.slimed = player.target
						S_StartSound(player.mo, sfx_splish)
					end
				end
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.mo.skin == "rimuru"
		player.target = P_LookForEnemies(player, true, false)
		if not (player.pflags & PF_THOKKED)
			if player.target
				local slime = P_SpawnMissile(player.mo, player.target, MT_SLIMETRAIL)
				slime.state = S_SLIMETRAIL
				slime.fuse = 15
				slime.color = player.mo.color
				
				local slime2 = P_SpawnMissile(player.target, player.mo, MT_SLIMETRAIL)
				slime2.state = S_SLIMETRAIL
				slime2.fuse = 15
				slime2.color = player.mo.color
				
				P_HomingAttack(player.mo, player.target)
				P_HomingAttack(player.target, player.mo)
				S_StartSound(player.mo, sfx_splish)
			else
				P_SpawnGhostMobj(player.mo)
				S_StartSound(player.mo, sfx_bnce2)
			end
			player.pflags = $|PF_THOKKED
		end	
	end
end)

addHook("MobjThinker", function(mo)
	if mo.valid
	and mo.state == S_SLIMETRAIL
		if not mo.target
			mo.scale = $ - FRACUNIT/15
			mo.spritexscale = $ - FRACUNIT/15
		elseif mo.fuse < 15
			mo.scale = $ - FRACUNIT/15
		end	
		if not mo.trail
			local slime = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_SLIMETRAIL)
			slime.state = S_SLIMETRAIL
			slime.fuse = 5
			slime.trail = true
			slime.color = mo.color
		end
	end
end)

addHook("ShouldDamage", function(mobj, mo, source, damage, damagetype)
	if mobj.type == MT_PLAYER and source == mo and not (damagetype == DMG_INSTAKILL or damagetype == DMG_CRUSHED)
	and mo
		if (mobj.scale > mo.scale)
			if not (mobj.flags & MF_BOSS)
				mobj.slimed = mo
				mo.slimed = mobj
				mobj.startscale = mobj.scale
				S_StartSound(mo, sfx_splish)
			end			
			return false
		end	
	end
	if mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS or mobj.flags & MF_MONITOR and mobj.health > 0
		if mo.skin == "rimuru" and source == mo
			if mo.player.pflags & PF_JUMPED
				if not mobj.slimed
					if not (mobj.flags & MF_BOSS)
						mobj.slimed = mo
						mo.slimed = mobj
						S_StartSound(mo, sfx_splish)
						mobj.startscale = mobj.scale
						return false
					else
						local bounce = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SLIMETRAIL)
						bounce.trail = true
						bounce.fuse = 50
						bounce.scale = FRACUNIT*3
						bounce.flags = $|MF_NOGRAVITY
						bounce.color = mo.color
						bounce.frame = $|FF_PAPERSPRITE
						local anglefix = R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y)
						bounce.angle = anglefix+ANGLE_90
						S_StartSound(bounce, sfx_bnce1)
						P_InstaThrust(mo, anglefix+ANGLE_180, mo.player.speed)
						return true
					end	
					return false
				end	
				return false
			end	
		end
	end
end)

addHook("MobjDamage", function(mo)
	if mo.skin == "rimuru"
		if mo.slimed
			mo.slimed.slimed = nil
			mo.slimed = nil
		end
		Splash(mo, mo.color)
		mo.scale = $ - FRACUNIT/5
	end	
end, MT_PLAYER)

addHook("MobjDeath", function(mo)
	if mo.skin == "rimuru"
		if mo.slimed
			mo.slimed.slimed = nil
			mo.slimed = nil
		end
		mo.flags2 = $|MF2_DONTDRAW
		mo.player.eyes.flags2 = $|MF2_DONTDRAW
		Splash(mo, mo.color)
	end	
end, MT_PLAYER)

/*addHook("MobjDamage", function(mobj, mo)
	if mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS or mobj.flags & MF_MONITOR and mobj.health > 0
		if mo.tracer and mo.type == MT_SLIMETRAIL
			local joinangle = R_PointToAngle2(mobj.x, mobj.y, mo.tracer.x, mo.tracer.y)
		
			local join = P_SpawnMobjFromMobj(mobj, 0, 0, mo.height/2, MT_SLIMETRAIL)
			join.fuse = 50
			join.color = mo.color
			P_InstaThrust(join, joinangle, 15*FRACUNIT)
			mo.tracer.scale = $ + FRACUNIT/15
			P_DamageMobj(mobj, mo.tracer, mo.tracer)
			P_KillMobj(mo)
		end
	end
end)*/

addHook("PlayerSpawn", function(player)
	if player.mo.skin == "rimuru"
		if player.mo.slimed
			if player.mo.slimed.slimed
				player.mo.slimed.slimed = nil
			end	
			player.mo.slimed = nil
		end	
		if player.eyes
			player.eyes = nil
		end
	end
end)

/*addHook("MobjThinker", function(mo)
	if mo.tracer
		local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
		if dist > 500*FRACUNIT
			P_HomingAttack(mo, mo.tracer)
		else
			P_HomingAttack(mo, mo.target)
		end
	end
end, MT_SLIMETRAIL)

addHook("MobjFuse", function(mo)
	if mo.tracer
		if mo.tracer.slimemissile
			mo.tracer.slimemissile = nil
		end
	end
end, MT_SLIMETRAIL)*/